import 'package:flutter/material.dart';
import 'package:stacked/stacked.dart';
import 'package:yimaru_app/ui/common/app_colors.dart';
import 'package:yimaru_app/ui/common/ui_helpers.dart';
import 'package:yimaru_app/ui/widgets/custom_elevated_button.dart';
import 'package:yimaru_app/ui/views/onboarding/onboarding_viewmodel.dart';
import 'package:yimaru_app/ui/widgets/onboarding_app_bar.dart';

import '../../onboarding_view.form.dart';

class OccupationForm extends ViewModelWidget<OnboardingViewModel> {
  final TextEditingController occupationController;

  const OccupationForm({super.key, required this.occupationController});

  @override
  Widget build(BuildContext context, OnboardingViewModel viewModel) =>
      _buildScaffoldWrapper(viewModel);

  Widget _buildScaffoldWrapper(OnboardingViewModel viewModel) => Scaffold(
        backgroundColor: kcBackgroundColor,
        body: _buildScaffold(viewModel),
      );

  Widget _buildScaffold(OnboardingViewModel viewModel) => Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: _buildScaffoldChildren(viewModel),
      );

  List<Widget> _buildScaffoldChildren(OnboardingViewModel viewModel) =>
      [_buildAppBar(), _buildExpandedBody(viewModel)];

  Widget _buildExpandedBody(OnboardingViewModel viewModel) =>
      Expanded(child: _buildBodyWrapper(viewModel));

  Widget _buildBodyWrapper(OnboardingViewModel viewModel) => Padding(
        padding: const EdgeInsets.symmetric(horizontal: 15),
        child: _buildBody(viewModel),
      );

  Widget _buildBody(OnboardingViewModel viewModel) => Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: _buildBodyChildren(viewModel),
      );

  List<Widget> _buildBodyChildren(OnboardingViewModel viewModel) =>
      [_buildUpperColumn(viewModel), _buildContinueButtonWrapper(viewModel)];

  Widget _buildUpperColumn(OnboardingViewModel viewModel) => Column(
        mainAxisSize: MainAxisSize.min,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: _buildUpperColumnChildren(viewModel),
      );

  List<Widget> _buildUpperColumnChildren(OnboardingViewModel viewModel) => [
        verticalSpaceMedium,
        _buildTitle(),
        verticalSpaceSmall,
        _buildSubTitle(),
        verticalSpaceLarge,
        _buildOccupationFormField(viewModel),
        if (viewModel.hasOccupationValidationMessage &&
            viewModel.focusOccupation)
          verticalSpaceTiny,
        if (viewModel.hasOccupationValidationMessage &&
            viewModel.focusOccupation)
          _buildOccupationValidatorWrapper(viewModel)
      ];

  Widget _buildAppBar() => const OnboardingAppBar();

  Widget _buildTitle() => const Text(
        'What’s your occupation?',
        style: TextStyle(
          fontSize: 25,
          color: kcDarkGreyColor,
          fontWeight: FontWeight.w600,
        ),
      );

  Widget _buildSubTitle() => const Text(
        'We’ll personalize your learning experience based on your occupation.',
        style: TextStyle(color: kcMediumGrey),
      );

  Widget _buildOccupationFormField(OnboardingViewModel viewModel) =>
      TextFormField(
        controller: occupationController,
        onTap: viewModel.setOccupationFocus,
        decoration: inputDecoration(focus: viewModel.focusOccupation),
      );

  Widget _buildOccupationValidatorWrapper(OnboardingViewModel viewModel) =>
      viewModel.hasOccupationValidationMessage
          ? _buildOccupationValidator(viewModel)
          : Container();

  Widget _buildOccupationValidator(OnboardingViewModel viewModel) => Text(
        viewModel.occupationValidationMessage!,
        style: const TextStyle(
          fontSize: 12,
          color: Colors.red,
          fontWeight: FontWeight.w700,
        ),
      );

  Widget _buildContinueButtonWrapper(OnboardingViewModel viewModel) => Padding(
        padding: const EdgeInsets.only(bottom: 50),
        child: _buildContinueButton(viewModel),
      );

  Widget _buildContinueButton(OnboardingViewModel viewModel) =>
      CustomElevatedButton(
        height: 55,
        text: 'Continue',
        borderRadius: 12,
        foregroundColor: kcWhiteColor,
        onTap: viewModel.focusOccupation && occupationController.text.isNotEmpty
            ? () => viewModel.next()
            : null,
        backgroundColor:
            viewModel.focusOccupation && occupationController.text.isNotEmpty
                ? kcPrimaryColor
                : kcPrimaryColor.withOpacity(0.2),
      );
}
